#!/usr/bin/python
# Listing 3.1
import math

def f(x):
    return math.cos(x) - x

def bisect(a, b):
    midpt = (a+b)/2.0
    tol = 1e-15
    if b - a > tol:
        val = f(midpt)
        if val*f(a) < 0:
            bisect(a, midpt)
        elif val*f(b) < 0:
            bisect(midpt, b)
        else:
            print("Root = %.13f" % (midpt))
    else:
        print("Root = %.13f" % (midpt))

bisect(0, 1)
